############################ -*- Mode: Makefile -*- ###########################
## local.mk --- 
## Author	    : Manoj Srivastava ( srivasta@glaurung.green-gryphon.com ) 
## Created On	    : Sat Nov 15 10:42:10 2003
## Created On Node  : glaurung.green-gryphon.com
## Last Modified By : Manoj Srivastava
## Last Modified On : Sat Dec  3 14:06:09 2005
## Last Machine Used: glaurung.internal.golden-gryphon.com
## Update Count	    : 23
## Status	    : Unknown, Use with caution!
## HISTORY	    : 
## Description	    : 
## 
## arch-tag: b07b1015-30ba-4b46-915f-78c776a808f4
## 
###############################################################################

testdir:
	$(testdir)

CLN-common::
	$(REASON)
	-test -f Makefile && $(MAKE) clean || true

# BUILD/mime-codecs:: build/mime-codecs
# INST/mime-codecs:: install/mime-codecs
# BIN/mime-codecs:: binary/mime-codecs

# CLEAN/mime-codecs::
# 	$(checkdir)
# 	$(REASON)
# 	-rm -rf $(TMPTOP)

BUILD/vm:: build/vm
INST/vm:: install/vm
BIN/vm:: binary/vm


CLEAN/vm::
	$(checkdir)
	$(REASON)
	-rm -rf $(TMPTOP)

build/mime-codecs: base64-decode.c base64-encode.c qp-decode.c qp-encode.c \
		   stamp-build-codecs

stamp-build-codecs:
	$(checkdir)
	$(REASON)
	$(CC) $(CFLAGS) base64-decode.c -o base64-decode
	$(CC) $(CFLAGS) base64-encode.c -o base64-encode
	$(CC) $(CFLAGS) qp-decode.c	-o qp-decode
	$(CC) $(CFLAGS) qp-encode.c	-o qp-encode
	dpkg -l gcc perl dpkg 'libc*' binutils ldso make dpkg-dev |\
	    awk '$$1 == "ii" { printf("%s-%s\n", $$2, $$3) }' > \
	      debian/buildinfo	
	touch stamp-build-codecs

STAMPS_TO_CLEAN += stamp-build-codecs

build/vm: stamp-build-vm

stamp-build-vm:
	$(checkdir)
	$(REASON)
	$(MAKE) vm.info
	test -d debian/html || mkdir debian/html
	(cd debian/html; \
	 texi2html -doctype html2 -expandinfo -glossary -menu \
		   -split_chapter -o . -verbose  ../../vm.texinfo)
	touch stamp-build-vm

STAMPS_TO_CLEAN += stamp-build-vm


install/mime-codecs: testroot
	$(REASON)
	$(checkdir)
	rm -rf $(TMPTOP)   $(TMPTOP).deb
	$(make_directory)  $(BINDIR)
	$(make_directory)  $(MAN1DIR)
	$(make_directory)  $(DOCDIR)
	$(install_program) base64-decode         $(BINDIR)
	$(install_program) base64-encode         $(BINDIR)
	$(install_program) qp-decode             $(BINDIR)
	$(install_program) qp-encode             $(BINDIR)
	$(install_file)    base64-decode.1       $(MAN1DIR)
	$(install_file)    base64-encode.1       $(MAN1DIR)
	$(install_file)    qp-decode.1           $(MAN1DIR)
	$(install_file)    qp-encode.1           $(MAN1DIR)
	$(install_file)    debian/README.debian  $(DOCDIR)/README.Debian 
	$(install_file)    debian/README.MIME    $(DOCDIR)
	$(install_file)    debian/changelog      $(DOCDIR)/changelog.Debian
	$(install_file)    debian/buildinfo      $(DOCDIR)/buildinfo.Debian
	gzip -9fqr         $(MANDIR)
	gzip -9fqr         $(DOCDIR)
	$(install_file)    debian/copyright      $(DOCDIR)
ifeq (,$(findstring nostrip,$(DEB_BUILD_OPTIONS)))
	find $(TMPTOP) -type f | while read i; do                                        \
           if file -b $$i | egrep -q "^ELF.*executable"; then                             \
             strip --strip-all --remove-section=.comment --remove-section=.note $$i;      \
           fi;                                                                            \
         done
endif


install/vm: testroot
	$(REASON)
	$(checkdir)
	rm -rf $(TMPTOP)   $(TMPTOP).deb
	$(make_directory)  $(INFODIR)
	$(make_directory)  $(LISPDIR)
	$(make_directory)  $(PIXMAPDIR)
	$(make_directory)  $(STARTDIRS)
	$(make_directory)  $(DOCDIR)/examples
	$(make_directory)  $(DOCBASE)
	$(make_directory)  $(COMPILEDIR)/install
	$(make_directory)  $(COMPILEDIR)/remove
	$(make_directory)  $(LINTIANDIR)
	echo	 "$(package): description-synopsis-might-not-be-phrased-properly" \
				>>		    $(LINTIANDIR)/$(package)
	$(install_file)    make-autoloads        $(LISPDIR)
	$(install_file)    Makefile *.el         $(LISPDIR)
	$(install_file)    debian/$(STARTFILE)   $(LISPDIR)
	$(install_file)    pixmaps/*.xbm         $(PIXMAPDIR)
	$(install_file)    pixmaps/*.xpm         $(PIXMAPDIR)
	$(install_file)    vm.info*              $(INFODIR)/
	$(install_file)    debian/changelog      $(DOCDIR)/changelog.Debian
	$(install_file)    debian/README.debian  $(DOCDIR)
	$(install_file)    debian/README.hilit19 $(DOCDIR)
	$(install_file)    vm-vars.el            $(DOCDIR)
	$(install_file)    README                $(DOCDIR)
	(cd debian/examples;  tar cf - * | (cd $(DOCDIR)/examples;tar xf -))
	(cd pixmaps;          tar cf - * | (cd $(PIXMAPDIR);      tar xf -))
	gzip -9fqr         $(INFODIR)/
	gzip -9frq         $(DOCDIR)/
# Make sure the copyright file is not compressed
	$(install_file)	   debian/copyright	 $(DOCDIR)/copyright
	$(install_file)    debian/html/vm_*.html $(DOCDIR)/
	$(install_file)    debian/html/vm.html   $(DOCDIR)/
	$(install_file)    debian/docentry       $(DOCBASE)/$(package)
	sed                -e 's/=P/$(package)/g' -e 's/=V/$(DEB_VERSION)/g' \
                                                 debian/emacsen.install > \
                                           $(COMPILEDIR)/install/$(package)
	sed                -e 's/=P/$(package)/g' -e 's/=V/$(DEB_VERSION)/g' \
                                                 debian/emacsen.remove  > \
                                            $(COMPILEDIR)/remove/$(package)
	chmod 0755         $(COMPILEDIR)/install/$(package) \
                            $(COMPILEDIR)/remove/$(package)


binary/mime-codecs: testroot
	$(checkdir)
	$(REASON)
	$(make_directory)  $(TMPTOP)/DEBIAN
	dpkg-shlibdeps     base64-decode base64-encode qp-decode qp-encode
	dpkg-gencontrol    -p$(package) -isp -P$(TMPTOP)
	chown -R root:root $(TMPTOP)
	chmod -R u+w,go=rX $(TMPTOP)
	dpkg --build       $(TMPTOP) ..


binary/vm: testroot
	$(REASON)
	$(checkdir)
	$(make_directory)  $(TMPTOP)/DEBIAN
	$(install_program) debian/postinst       $(TMPTOP)/DEBIAN/postinst
	$(install_program) debian/prerm          $(TMPTOP)/DEBIAN/prerm
	$(install_program) debian/postrm         $(TMPTOP)/DEBIAN/postrm
	dpkg-gencontrol    -p$(package) -isp -P$(TMPTOP)
	chown -R root:root $(TMPTOP)
	chmod -R u+w,go=rX $(TMPTOP)
	dpkg --build       $(TMPTOP) ..



#Local variables:
#mode: makefile
#End:
